[![Build Status](https://git.luker.fr/ldooks/dragon-bot/actions/workflows/build-and-push.yaml/badge.svg?branch=master)](https://drone.luker.fr/ldooks/dragon-bot)
# README #

A Discord bot written in python.

This project was used mainly to teach members of the Discord channel about software development, docker, CI/CD, and for me to learn about project management

Currently the CI/CD pipeline has workers running as Kubernetes pods and dispatches jobs to various nodes. Once a new container is built, it is automatically deployed

### What does this bot do? ###
* This is a chat bot of sorts that connects to our [Discord](https://discordapp.com/) channel and interacts with us via chat commands
* This bot has also been an ongoing learning experience for several members of the Discord channel. With this bot, I have been able to teach the repo contributors:
	* Docker
	* Helm
	* Kubernetes
	* ArgoCD
	* Git
	* Python
	* CI/CD (First using gitlab CI, but now I've deployed my own DroneCI cluster)
	* Collaborative coding practices
	* Testing methodologies
	* Code Accountability

* You can see a diagram of how it all works by running the following command from the root of the repo:
```bash
docker run --rm -v $(pwd):/tmp/python python sh -c "apt-get update && apt-get install -y graphviz; pip install diagrams; cd /tmp/python; python /tmp/python/dalebot-overview.py"
```

### What is this repository for? ###

* Here we track issues and collaborate on the bot

## How do I get set up? ###

### Installing docker
* linux
	* as root (`sudo -s`)
	* `curl -Ls get.docker.com | bash`
	* Give yourself docker permissions `sudo usermod -aG docker <your username>`
* OS X
	* `curl -L get.macapps.link/en/docker | bash`
	* open /Applicaitons/Docker.app
	* Complete the setup steps
* Windows
  * See [This](https://medium.com/@sebagomez/installing-the-docker-client-on-ubuntus-windows-subsystem-for-linux-612b392a44c4) guide


### Who do I talk to? ###

* Luke in Discord
